// For general information on the Pynini grammar compilation library, see
// pynini.opengrm.org.

#include "join.h"

namespace strings {

namespace internal {

size_t GetResultSize(const std::vector<string> &elements, size_t s_size) {
  size_t length = 0;
  for (const string &element : elements)
    length += element.size();
  return length + s_size * (elements.size() - 1);
}

}  // namespace internal

string Join(const std::vector<string> &elements, const string &separator) {
  string result;
  if (elements.empty()) return result;
  size_t s_size = separator.size();
  result.reserve(internal::GetResultSize(elements, s_size));
  auto it = elements.begin();
  result.append(it->data(), it->size());
  for (++it; it != elements.end(); ++it) {
    result.append(separator.data(), s_size);
    result.append(it->data(), it->size());
  }
  return result;
}

}  // namespace strings
