// For general information on the Pynini grammar compilation library, see
// pynini.opengrm.org.

#include <fst/script/fst-class.h>
#include <fst/script/script-impl.h>
#include "repeatscript.h"

namespace fst {
namespace script {

void Repeat(MutableFstClass *fst, int lower, int upper) {
  RepeatArgs args(fst, lower, upper);
  Apply<Operation<RepeatArgs>>("Repeat", fst->ArcType(), &args);
}

REGISTER_FST_OPERATION(Repeat, StdArc, RepeatArgs);
REGISTER_FST_OPERATION(Repeat, LogArc, RepeatArgs);
REGISTER_FST_OPERATION(Repeat, Log64Arc, RepeatArgs);

}  // namespace script
}  // namespace fst

