// For general information on the Pynini grammar compilation library, see
// pynini.opengrm.org.

#include "split.h"

namespace strings {

std::vector<string> Split(const string &str, char separator) {
  std::vector<string> tokens;
  auto left = str.begin();
  auto end = str.end();
  auto not_separator = [separator](char ch){ return ch == separator; };
  while (left != end) {
    left = std::find_if_not(left, end, not_separator);
    if (left == end) break;  // FIXME(kbg) do I need this?
    auto right = std::find(left, end, separator);
    tokens.emplace_back(string(left, right));
    left = right;
  }
  return std::move(tokens);
}

}  // namespace strings
